import React, { Component } from "react";
import style from "../index.less";
import deleteIcon from '@common/images/delete.png';
import allTableIcon from '@common/images/all-table.png';
import level1 from "@common/images/级别1.png";
import checkIcon from '@common/images/check.png';
import {ComplexModal,MiniToast,Radio} from '@commonComp';
import Notify from '@commonComp/Notify';
import {deepClone} from '@utils/tools';
import { getFormulaResult } from '@store/async-actions/fetchModules'
/**
 * 来源于页面选择
 *
 * **/
class ScaleItem extends Component {
  constructor(props) {
    super(props);
    this.$area = React.createRef();
    const {result}= props;
    let radioVal = result&&result.radioVal;
    this.state = {
      scaleId:'',
      scaleName:'',
      parentId:'',
      showScale:false,
      optionId:'',
      radioVal:Object.assign({},radioVal)||{},
      formulaId:'',
      text:props.text,
      isCalculated:false,
      calcuValues:deepClone(props.calcuValues),   //计算公式填的值
    };
    this.getItems = this.getItems.bind(this);
    this.getDetailItems = this.getDetailItems.bind(this);
    this.showOption = this.showOption.bind(this);
    this.closeOption = this.closeOption.bind(this);
    this.closeFormula = this.closeFormula.bind(this);
    this.handleInputformula =this.handleInputformula.bind(this);
  }
  showOption(id){
    this.setState({
      optionId:id
    })
  }
  closeOption(){
    const {result} = this.props;
    const possible=result&&result.possible;
    let {radioVal} = this.state;
    this.setState({
      radioVal:Object.assign({},radioVal,possible),
      optionId:null,
    });
  }
  confirmOption(){
    const {handleRes} = this.props;
    const {radioVal} = this.state;
    handleRes&&handleRes({
      possible:Object.assign({},radioVal),
      radioVal:Object.assign({},radioVal),//不设置radioVal只有最近一次选中的值
    });
    this.setState({
      optionId:null,
    });
  }
  handleShowScale(item){
    const {showScaleFn,closeAssess} = this.props;
    //closeAssess&&closeAssess();    //关闭评估弹窗
    showScaleFn&&showScaleFn(item);
  }
  handleRadio(item,parent){
    let {result} = this.props;
    let radioVal = result&&result.radioVal;
    this.setState({
      radioVal:Object.assign({},radioVal,{[parent.id]:item.detailName})
    })
  }
  handleInputformula(id,calcuContent,i,e) {
    const {calcuValues} = this.state;
    let obj = deepClone(calcuValues);
    let values = (obj&&obj[id])||deepClone(calcuContent);
    values[i].value = e.target.value;
    obj[id] = values;
    this.setState({
      isCalculated:false,
      calcuValues:obj
    });
  }
  handleForRadio(id,calcuContent,i,fidx){//计算公式
    const { calcuValues } = this.state;
    let obj = deepClone(calcuValues);
    let values = (obj&&obj[id])||deepClone(calcuContent);
    let details = values[i].details;
    for(let x=0;x<details.length;x++){
      if(x!=fidx){
        details[x].state=0;
      }else{
        details[x].state=1;
      }
    }
    obj[id] = values;
    this.setState({
      isCalculated:false,
      calcuValues:obj
    });
  }
  showFormula(id){
    this.setState({
      formulaId:id
    });
  }
  closeFormula(){
    if(this.state.isCalculated){
      this.setState({
        formulaId:null,
      });
    }else{
      this.setState({
        formulaId:null,
        calcuValues:deepClone(this.props.calcuValues)
      });
    }
  }
  calcuFormula(item) { //计算公式计算
    const { calcuResult,handleCalcu } = this.props;
    const {formulaId,calcuValues} = this.state;
    let it=calcuValues&&calcuValues[formulaId];
    let allHasInfo = true;
    for (let i = 0; i < it.length; i++) {
      if(it[i].controlType == 2) {  //输入框类型的有没有填值
        if(!it[i].value) {
          allHasInfo = false
        }
      } else if(it[i].controlType == 0) {
        let hasSelect = false;
        for( let z = 0; z <it[i].details.length; z++) {
          if(it[i].details[z].state == 1) {
            hasSelect= true
          }
        }
        if(!hasSelect) {
          allHasInfo = false
        }
      }
    }
    item.content.details = calcuValues[formulaId];
    if(allHasInfo) { //所有都有值，则计算
      let results = deepClone(calcuResult);
      getFormulaResult({type:2,data:item}).then((res)=>{
        if(+res.data.code==0){
          const result = res.data.data.result;
          results[formulaId] = result;
          handleCalcu&&handleCalcu(calcuValues,results);
          this.setState({
            isCalculated:true
          });
        }else{
          Notify.error(res.data.msg||'计算没有结果返回');
        }
      })
    } else {  //不是所有值都填过了
      Notify.info('请填写计算公式内容')
    }
  }
  getDetailItems(item,i){
    let arr = [],temp='';
    const {indexs,result,formulaResult,disabled,calcuResult} = this.props;
    const {optionId,formulaId,radioVal,calcuValues} = this.state;
    const possible=result&&result.possible;

    item.details.map((its,j)=>{
      let it=its;
      if(indexs[i]&&indexs[i].includes(j)){
        if(its.type==1){     //量表
          let scaleRes=formulaResult&&formulaResult[it.content.id]&&formulaResult[it.content.id].calcalculate;
          temp =<span className={style['scale']}
                      onClick={()=>this.handleShowScale(it.content)}>
                        {scaleRes&&scaleRes.result?(' 【'+it.content.name+'】 结果：'+scaleRes.result.value+" "+(scaleRes.result.text||'')):'【'+it.content.name+'】'}
                        </span>;
        }else if(its.type==2){      //计算公式
          const showRes = calcuResult&&calcuResult[item.id]||it.content.result;
          const details = calcuValues&&calcuValues[item.id]||it.content.details;
          const cresult = showRes&&showRes[1]&&showRes[1].text;
                    temp = <div className={style['results']}>
                    <span>计算公式结果：</span>
                    <span className={style["blue"]} onClick={this.showFormula.bind(this,item.id,it)}>{cresult?cresult:'请选择'}</span>
                    <img src={level1} />
                    <MiniToast title={it.content.name}
                               confirmText='关闭'
                               icon={allTableIcon}
                               show={formulaId&&formulaId==item.id?true:false}
                               close={this.closeFormula}
                               confirm={this.closeFormula}
                               footer="true">
                      <table>
                        {details.map((item1,idd)=>{
                          if(item1.controlType==0){//单选
                            return <tr>
                              <td>
                                <span>{'请选择'+item1.name+'：'}</span>
                              </td>
                              <td>
                                {item1.details.map((ii,ind)=>{
                                  return <div className={style["chooseItem"]}>
                                    <Radio label={ii.detailName}
                                           isSelect={ii.state == 1}
                                           disabled={disabled}
                                           handleClick={this.handleForRadio.bind(this,item.id,details,idd,ind)}>
                                      >
                                    </Radio>
                                  </div>
                                })}
                              </td>
                            </tr>
                          }else if(item1.controlType==2){//输入框
                            return <tr>
                              <td>
                                <span>{'请输入'+item1.name+'：'}</span>
                              </td>
                              <td>
                                {disabled?item1.value:<input type="text" placeholder="请输入"  value={item1.value} onInput={(e)=>this.handleInputformula(item.id,details,idd,e)}/>}
                              </td>
                              <td>
                                <span>{item1.uint}</span>
                              </td>

                            </tr>
                          }
                        })}
                      </table>
                      {disabled?"":<div className={style["forMulBtn"]} onClick={this.calcuFormula.bind(this,its)}>计算</div>}
                      <table>
                        {showRes && Array.isArray(showRes) &&showRes.map((itemResult) => {
                          return <tr>
                            <td>
                              <span>{itemResult.name+'：'}</span>
                            </td>
                            <td>
                              <span>{itemResult.text}</span>
                            </td>
                          </tr>
                        })}
                      </table>
                    </MiniToast>
                </div>
        }else if(its.type==3){
          temp = <div className={style['results']}>
                    <span>可能结果：</span>
                    <span onClick={this.showOption.bind(this,item.id)} className={style["blue"]}>{possible&&possible[item.id]?possible[item.id]:'请选择'}</span>
                    <img src={level1} />
                    <MiniToast title='结果选择'
                         icon={checkIcon}
                         show={optionId&&optionId==item.id?true:false}
                         close={this.closeOption}
                         confirm={this.confirmOption.bind(this,item.id)}
                         footer="true">
                        <div className={style["infoOption"]}>
                          <span>{it.content.name?it.content.name+'：':''}</span>
                          {it.content.details&&it.content.details.map((lis,ind)=>{
                            return <div className={style["chooseItem"]}>
                              <Radio label={lis.detailName}
                                     disabled={disabled}
                                     isSelect={radioVal&&radioVal[item.id]==lis.detailName}
                                     handleClick={this.handleRadio.bind(this,lis,item,i)}>
                              </Radio>
                              {lis.state==1?<span className={style['recomand']}>（智能推荐）</span>:''}
                            </div>
                          })}
                        </div>
                    </MiniToast>
                  </div>;
        }
        const passId = item.details[j].type==1?item.details[j].content.id:undefined;
        const li = disabled?<li>
            <span>{item.name}：</span>
            <div className={style['row']}>{temp}</div>
          </li>:<li>
          <span>{item.name}：</span>
          <div className={style['row']}>{temp}</div>
          <div className={style["recommend"]} onClick={()=>this.props.handleRemove(false,i,passId,j)}>
            <img className={style["deleteIcon"]} src={deleteIcon} />
          </div>
        </li>;
        arr.push(li);
      }
    });
    return arr;
  }
  getItems(){
    const { data } = this.props;
    return data&&data.map((it,i)=>{
      return this.getDetailItems(it,i);
    });
  }
  getScales(){
    const {scaleItems,disabled,formulaResult} = this.props;
    let li='',temp='';
    const arr = scaleItems&&scaleItems.map((it,i)=>{
      if(!it) return '';
      let scaleRes=formulaResult&&formulaResult[it.id]&&formulaResult[it.id].calcalculate;
      temp =<span className={style['scale']} onClick={()=>this.handleShowScale(it)}>
                        {scaleRes&&scaleRes.result?(' 【'+it.name+'】 结果：'+scaleRes.result.value+" "+(scaleRes.result.text||'')):'【'+it.name+'】'}
                        </span>;
      li = disabled?<li>
        <span>相关量表：</span>
        <div className={style['row']}>{temp}</div>
      </li>:<li>
        <span>相关量表：</span>
        <div className={style['row']}>{temp}</div>
        <div className={style["recommend"]} onClick={()=>this.props.handleRemove(true,i,it.id)}>
          <img className={style["deleteIcon"]} src={deleteIcon} />
        </div>
      </li>;
      return li;
    });
    return arr;
  }
  handleInput(e){
    const text = e.target.value;
    this.setState({
      text
    });
  }
  componentWillReceiveProps(next){        //修复bug1329,第二次保存值不显示
    if(next.text!=this.state.text){
      this.setState({
        text:next.text
      });
    this.$area.current.value=next.text;
    }
  }
  render() {
    const {title,handleInp,disabled} = this.props;
    return <div className={style['assess-item']}>
      <h2>{title}</h2>
      <div className={style['item-content']}>
        <ul>
          {
            this.getItems()
          }
          {
            this.getScales()
          }
          <li>
            <textarea className={style['edit-row']}
                      ref={this.$area}
                      type="text"
                      disabled={disabled}
                      placeholder='评估描述'
                      onBlur={()=>handleInp(this.state.text)}
                      onInput={this.handleInput.bind(this)}>{this.state.text}</textarea>
            <div className={style['textareaStatic']}>评估描述：{this.state.text}</div>
          </li>
        </ul>
      </div>
    </div>;
  }
}

export default ScaleItem;